RadixSort3 PROC uses esi edi ebx Arr:DWORD, count:DWORD

    ; a RadixSort by Jim Giordano

    local Table[256*4]  ; number of items found for each possible byte
                        ; will be then converted to absolute addresses
    mov eax,count
    cmp eax,2
    jb nosort
    
;   note: heap is preallocated so all tests use the same spot in memory.
;    shl eax,2
;    ;invoke SysAllocStringByteLen,0,eax ; otherwise one of these would be used
;    inv HeapAlloc,hHeap,0,eax
;    mov xheap,eax

    lea edi,Table  ; clear the Table array
    mov ecx,256 * 4
    xor eax,eax
    rep stosd

    mov ecx,count   ; compute size needed for each possible byte
    mov esi,Arr
    xor ebx,ebx
    align 4
    .repeat
        lodsd           ; count number of bytes found of each value
        mov bl,al       ;   in least significant byte position
        add dword ptr Table[ebx*4],4  ; add 4 bytes/dword
        
        mov bl,ah
        add dword ptr Table[ebx*4+256*4],4   ; count number of 2nd least sigficant
        
        shr eax,16
        mov bl,al
        add dword ptr Table[ebx*4+2*256*4],4
        
        mov bl,ah
        add dword ptr Table[ebx*4+3*256*4],4 ; count number of most significant        
        
        dec ecx
    .until zero?

    ; convert counts to offsets
        
    lea edi,Table
    mov edx,3           ; once for each normal byte
    mov esi,xheap       ; first output will be to xheap
    align 4
    .repeat
        mov eax,esi     ; starting offset
        mov ecx,256
        .repeat
            mov ebx,[edi]   ; number of bytes found with this value
            mov [edi],eax   ; save offset from start of array
            add eax,ebx     ; compute next offset
            add edi,4
            dec ecx
        .until zero?
        mov ecx,esi
        mov esi,Arr
        .if esi==ecx
            mov esi,xheap
        .endif
        dec edx
    .until zero?

    ; now one time for final byte to account for negative numbers
    mov edx,2
    add edi,128*4   ; do second half first
    mov eax,Arr     ; where to store
    .repeat
        mov ecx,128 ; do half
        align 4
        .repeat
            mov ebx,[edi]   ; number of bytes found for current value
            mov [edi],eax   ; save offset from start of array
            add eax,ebx     ; compute next offset
            add edi,4
            dec ecx
        .until zero?
        sub edi,256*4      ; go back for positive numbers
        dec edx
    .until zero?
    
    ; now copy the data by bytes from Arr to xheap and back again, twice.
    ;  one copy for each 256 bit "digit"

    xor ebx,ebx     ; where the table address will be constructed
    
    mov esi,Arr     ; first input
    mov ecx,count
    align 4
    .repeat
        mov bl,byte ptr [esi] ; get lowest byte
        mov edi,Table[ebx*4] ; output address for this value byte
        movsd
        mov Table[ebx*4],edi ; where next one will go
        dec ecx
    .until zero?

    mov esi,xheap   ; next input
    mov ecx,count
    align 4
    .repeat
        mov bl,byte ptr [esi+1] ;ah       ; working on second byte
        mov edi,Table[ebx*4+256*4] ; output offset
        movsd
        mov Table[ebx*4+256*4],edi ; where next one will go
        dec ecx
    .until zero?

    mov esi,Arr     ; next input
    mov ecx,count
    align 4
    .repeat
        mov bl,byte ptr [esi+2] ;ah       ; working on second byte
        mov edi,Table[ebx*4+2*256*4] ; output offset
        movsd
        mov Table[ebx*4+2*256*4],edi ; where next one will go
        dec ecx
    .until zero?

    mov esi,xheap   ; final input
    mov ecx,count
    align 4
    .repeat
        mov bl,byte ptr [esi+3] ;ah       ; working on second byte
        mov edi,Table[ebx*4+3*256*4] ; output offset
        movsd
        mov Table[ebx*4+3*256*4],edi ; where next one will go
        dec ecx
    .until zero?
    
;   note: heap is preallocated to make sure all tests have an equal opportunity
;    ;invoke SysFreeString, xheap
;    inv HeapFree,hHeap,0,xheap

nosort:
	ret
RadixSort3 endp
Rdx3=$-RadixSort3
